//========================================================================
// SCIDYNE Corporation   649 School Street   Pembroke, MA 02359-3649 USA
// Tel: (781) 293-3059   Fax: (781) 293-4034   URL: http://www.scidyne.com 
//========================================================================
// NOTICE:
//    This work is licensed under a Creative Commons Attribution-ShareAlike 3.0 Unported License. 
//    http://creativecommons.org/licenses/by-sa/3.0/us/
//
//    and is based on the original work of Andy Brown:  
//    http://andybrown.me.uk/wk/2011/08/28/512kb-sram-expansion-for-the-arduino-mega-software/
//========================================================================
// Project  :  XMEM+                                        
// File     :  xmem_plus_example.ino                                             
// Revision :  1.01                                               
// Date     :  12-03-15 
// Author:  :  Mark Durgin
// Target   :  Arduino Mega 2560, Arduino Mega ADK
// Compiler :  Arduino                                                 
//========================================================================
// Description and usage: 
//    This program merges the existing test_xmem software with the xmem works of andy brown.
//
//    Note: The xmem_plus.h and xmem_plus.ino files located in this directory are required
//          and appear as additional tabs in test_xmem_06 within the Arduino IDE.
//
//========================================================================
// Issues, Concerns and "THINGS TO DO":
//
//========================================================================
// History:
//  12-03-15:
//    - Cleaned-up and added comments
//    - Moved the calling of selfTest() from setup() to loop() so it runs repeatedly.
//  07-25-15:  R0.00   - Project Begins
//========================================================================

#include "xmem_plus.h"

// Global variables
char buf[80];                      // A display buffer for using sprintf 

//************************************************************************
// Program initialization
//************************************************************************
void setup()
{
  xmem::begin(true);                // Activate the external memory, set heap to use XMEM+ SRAM
  Serial.begin(9600);               // Setup communications to IDE serial monitor
}


//************************************************************************
// This is the main loop
//************************************************************************
void loop()
{
  
  xmem::SelfTestResults results;    // Create a results structure
  
  
  // Run the XMEM+ selftest. Results are displayed on the Arduino IDE serial monitor
  results = xmem::selfTest();       // Run a self test on XMEM+ memory
 
  if(!results.succeeded)            
  {
    Serial.println("fail");
    sprintf(buf,"Bank: %d   Address: %04X", results.failedBank, results.failedAddress);
    Serial.println(buf);
  } 
  else
    Serial.println("pass");
  
}




